
//--------------------------------------
//	΂ēǂ
//	bigread 
//	
//	2002/06/22-
//	1991-2002 Copyright Tabasa & charlie, All rights reserved
// 	happypoint@geocities.co.jp
//	http://www.geocities.co.jp/SiliconValley-Bay/6716/
//
//


#define	_main

#include "defextern.h"

#include "main.h"
#include <richedit.h>
#include "bigread.h"
#include "commandline.h"
#include "file.h"
#include "editproc.h"
#include "font.h"

BOOL CALLBACK DlgProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
HINSTANCE hInstance;
char AppName[]="bigread";
char TopName[]="΂ēǂ";
char fontfile[MAX_PATH]="font.ini";

char filename[MAX_PATH];
#define buffermax 32000
#define buffermin 320
int edittopX=5;
int edittopY=35;
int defX=160;
int defY=430;

int posstep=1000;
int stepmore=1000;
int stepmost=100000;
char *buffer ;
//char buffer [buffermax+1]="ready.";
ULONG length=1000;
ifstream in;



int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
	hInstance=hInst;
	
	setcommandline(szCmdLine);
     if (-1 == DialogBox (hInstance, AppName, NULL, (int (__stdcall *)(void))DlgProc))
     {
          MessageBox (NULL, TEXT ("error"),
                      AppName, MB_ICONERROR) ;
     }
     return 0 ;
}

void reset(ifstream &in)
{
	in.close();
	in.clear();
	in.open(filename,ios::binary | ios::nocreate);
	//pos =0;
}

void setpos(ifstream &in)
{
	reset(in);
	in.seekg(pos,ios::beg);
}


void title(HWND hwnd,char *filename,char *thisname)
{
	char title[MAX_PATH *2];

	sprintf(title,"%s..%s",filename,thisname);
	SetWindowText(hwnd,title);

}


//---------------------------------------------
// ǂݍ݁A\
// ̍s

void show(ifstream &in)
{
	char *buff,*start;
	int count,countstart=0;
	BOOL flag=FALSE;
	in.read(buffer,buffermax);
	count=in.gcount();
	if(count==0)
	{
		reset(in);
		in.seekg(-buffermin,ios::end);
		if(!in.good()) reset(in);
		in.read(buffer,buffermax);
		count=in.gcount();
	}
	if(count<buffermax)
	{
		reset(in);
		in.seekg(-count,ios::end);
	}
	else
	{
		in.seekg(-count,ios::cur);
	}
	buff=&(buffer[0]);
	start=buff;
	for(int i=0;i<count;i++,buff++)
	{
		if(*buff=='\0') *buff=' ';
		if(pos!=0 && !flag && *buff==0x0a) //蔲@s
		{
			flag=TRUE;
			start=buff+1;
			countstart=i;
		}
	}
	buffer[count]='\0';
	/*
	SetBkMode(GetWindowDC(hwndEdit),OPAQUE);
	SetTextColor(GetWindowDC(hwndEdit),RGB(0,199,10));
	*/
	SetWindowText(hwndEdit,start);
	wsprintf(buffer,"%lu",pos+countstart);
	SetDlgItemText(hwndMain,IDC_EDIT1,buffer);
	setscrollmax();
	if(!bigflag)
	{
		SetScrollPos (hwndscroll, SB_CTL, pos, TRUE) ;
	}
	else
	{
		SetScrollPos (hwndscroll, SB_CTL, PosToScroll(pos), TRUE) ;
	}
}

void posplus(ifstream &in,int posplus)
{
	if(!in) return;
	streampos now=in.tellg();
	ULONG posback =pos;
	in.seekg(posplus,ios::cur);
	pos += posplus;
	if(pos>filesize) pos=filesize;
	if(!in.good() && posplus>0)
	{
		reset(in);
		in.seekg(now);
		pos =posback;
	}
	else if(!in.good() && posplus<0)
	{
		reset(in);
		pos =0;
	}
}

void getposedit(ifstream &in,ULONG &pos)
{
	reset(in);
	GetDlgItemText(hwndMain,IDC_EDIT1,buffer,buffermax);
	sscanf(buffer,"%ld",&pos);
	in.seekg(pos,ios::beg);
}

void ending(HWND hwnd)
{
	EndDialog (hwnd, 0) ;
	free(buffer);
	FontDeinitialize ();
}

//--------------------------------------
//	C



BOOL CALLBACK DlgProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT	paintstruct;
	 HDC hdc;
	 WORD cxClient,cyClient;

	 ULONG i,j;
	

     switch (message)
     {
		case WM_INITDIALOG:
			buffer = (char*)malloc (buffermax+1) ;
			hwndMain=hwnd;
			PopFileInitialize (hwnd);
			SetWindowText(hwnd,TopName);
			SetClassLong(hwnd,GCL_HICON,
				(long)LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON1)) );
			
          hwndEdit = CreateWindow (TEXT ("edit"), NULL,
                           WS_CHILD | WS_VISIBLE |WS_HSCROLL |
                                   WS_BORDER | ES_LEFT | ES_MULTILINE |
                                   ES_AUTOHSCROLL | ES_AUTOVSCROLL,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                         hwnd, NULL, hInstance,NULL) ;
		  hwndscroll = CreateWindow (TEXT ("scrollbar"), NULL,
							WS_CHILD | WS_VISIBLE | 
							WS_TABSTOP | SBS_VERT,
							0,0,0,0,
							 hwnd, NULL, hInstance, NULL) ;
		  SetScrollRange (hwndscroll, SB_CTL, 0,0, TRUE) ;
			FontInitialize (hwndEdit,fontfile);
			FontSetFont (hwndEdit);

		  pos=0;
		  SendMessage (hwnd, WM_SIZE, 0 , (LPARAM) MAKELONG(defY,defX) ) ;
		  DragAcceptFiles(hwnd,TRUE);
		  if(cmdflag)
		  {
			  FncCommandline(filename);
			  SendMessage (hwnd, WM_COMMAND, IDC_FILE_READ ,0);
		  }
		return TRUE ;


		case WM_VSCROLL :
          switch (LOWORD (wParam))
          {
          case SB_PAGEDOWN :
               scroll (IDC_NEXT2);
			   break;

          case SB_LINEDOWN :
               scroll (IDC_NEXT);
               break ;
               
          case SB_PAGEUP :
               scroll (IDC_BACK2 );
               break;

          case SB_LINEUP :
               scroll (IDC_BACK );
               break ;
               
          case SB_TOP :
               scroll (IDC_BACK_MOST );
               break ;
               
          case SB_BOTTOM :
               scroll (IDC_NEXT_MOST );
               break ;

		case SB_THUMBTRACK :
               if(!bigflag) pos = HIWORD (wParam);
			   else pos = (double)HIWORD (wParam) /scrollmax *filesize;
			   setpos(in);
			   show(in);
               break ;

          default :
               break ;
          }

		break;

	case WM_DROPFILES:
		DragQueryFile((HDROP)wParam,0,filename,MAX_PATH);
		SendMessage (hwnd, WM_COMMAND, IDC_FILE_READ ,0);
		break;

     case WM_SIZE : 
          cxClient = LOWORD (lParam) ;
          cyClient = HIWORD (lParam) ;
		 MoveWindow (hwndEdit, edittopX, edittopY,
                           cxClient-edittopX-25, cyClient-edittopY-5, TRUE) ;

		 MoveWindow (hwndscroll, cxClient-edittopX-18, edittopY,
                           13, cyClient-edittopY-5, TRUE) ;
         return 0 ;

     case WM_COMMAND:
          switch (LOWORD (wParam))
          {
		  case IDC_FILE_OPEN:
			  PopFileOpenDlg (hwnd,filename,NULL);
		  case IDC_FILE_READ:
			  pos=0;
			  reset(in);
			  filesize=getfilesize(filename);
			  title(hwnd,filename,TopName);
			  show(in);
			  break;

		  case IDC_BACK:
			  posplus(in,-posstep);
			  show(in);
			  break;

		  case IDC_BACK2:
			  posplus(in,-posstep * stepmore);
			  show(in);
			  break;

		  case IDC_BACK3:
			  posplus(in,-posstep * stepmost);
			  show(in);
			  break;

		  case IDC_BACK_MOST:
			  reset(in);
			  pos=0;
			  show(in);
			  break;

		  case IDC_NEXT:
			  posplus(in,posstep);
			  show(in);
			  break;

		  case IDC_NEXT2:
			  posplus(in,posstep * stepmore);
			  show(in);
			  break;

		  case IDC_NEXT3:
			  posplus(in,posstep * stepmost);
			  show(in);
			  break;

		  case IDC_NEXT_MOST:
			  pos=filesize;
			  in.seekg(0,ios::end);
			  show(in);
			  break;

		  case IDM_font:
			  FontChooseFont (hwndEdit);
			  FontSetFont (hwndEdit);
			  break;

		  case IDM_load_font:
			  loadfont(fontfile);
			  FontSetFont (hwndEdit);
			  break;

		  case IDM_save_font:
			  savefont(fontfile);
			  break;

		  case IDOK:
			  getposedit(in,pos);
			  show(in);
			  break;

		  case IDCANCEL:
			  ending(hwnd);
			  break;

          }
          break ;


     case WM_SYSCOMMAND:
          switch (LOWORD (wParam))
          {
          case SC_CLOSE:
			  //XbhI
			  ending(hwnd);
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}
